//===============================//
// Copyright
// Klett-Autor S. Krivsky-Velten
// 2006
//===============================//

import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;


public class FlaechSch extends Applet {
//===============================//

 oben Kontrolle;
 mitte Feld;
 int MengenAnz = 4;
 int Bildbreite = 250;
 int Bildhoehe = 250;
 int Menuewahl = 1;
 int LsgFlaeche = 0;
 int Anzbilder = 10;

 //Variablen fuer Bild

 String Dateiname;
 int diam = 5;			// Durchmesser des Kaestchens
 int diami = 5;
 int Anzx = 50;			// Bildbreite / diam
 int Anzy = 50;			// Bildhoehe / diam
 int xa = 20;
 int ya = 30;
 int Anix, Aniy;
 int[][] Felder = new int[Anzx][Anzy];
 int[][][] Icons = new int[3][Anzx][Anzy];
 Color[] Farbwahl = {new Color (180, 0, 0), new Color(64, 128, 200), new Color(250, 200, 100), new Color(32, 200, 0)};


 int Buchh = 12;		// Hoehe der Schrift
 Font SchriftArt=new Font("Helvetica",Font.BOLD,16);
 Font SchriftArtklein=new Font("Helvetica",Font.PLAIN,Buchh);

 boolean Menuesituation = true;
 int Antwort = 0;



 public void init() {
   setBackground(Color.white);
   setLayout(new BorderLayout());
   Kontrolle  = new oben(this);
   add("Center", Feld = new mitte(this));
 } // init



 public void start() {
   Feld.init();
   Feld.ini_Menuewahl_Bild();
   Feld.maleMenue();


 }



 public void Menue() {
	Feld.Kontrollsituation = false;
	Kontrolle.Kommentar1.setText("Sch\u00E4tze wie viel Prozent der Fl\u00E4che rot ist:");
	Kontrolle.Kommentar2.setText(" % ");
	Kontrolle.AntwortTxt.setText("  ");
	  switch (Menuewahl) {
	  	case 1: {Menuewahl_Rechteck(); break;}
	  	case 2: {Menuewahl_Quadrate(); break;}
	  	case 3: {Menuewahl_Kreuz(); break;}

	  	case 4: {Menuewahl_Dreieck(); break;}
	  	case 5: {Menuewahl_Drachen(); break;}
	  	case 6: {Menuewahl_Sechsecke(); break;}

	  	case 7: {Menuewahl_Muster(); break;}
	  	case 8: {Menuewahl_Zufall(); break;}
	  	case 9: {Menuewahl_Bild(); break;}
	  }
	  Feld.maleBildflaeche();
 }


 public void Menuewahl_Rechteck() {
	Random rz;//initialisiere Zufallsz.
	rz = new Random();
	LsgFlaeche = 0;
	Feld.markant[0] = Math.abs(rz.nextInt())%(Bildbreite/2); // linkeEcke Rechteckpkt
	Feld.markant[1] = Math.abs(rz.nextInt())%(Bildhoehe/2);  // obere Ecke Rechteckpkt
	Feld.markant[2] = 20+Math.abs(rz.nextInt())%(Bildbreite-Feld.markant[0]-22); // Breite Rechteck
	Feld.markant[3] = 20+Math.abs(rz.nextInt())%(Bildhoehe-Feld.markant[1]-22); // Hoehe Rechteck
	LsgFlaeche = Feld.markant[2]*Feld.markant[3];
	LsgFlaeche = LsgFlaeche*100/(Bildbreite*Bildhoehe);
 }

 public void Menuewahl_Quadrate() {
	Random rz;
	rz = new Random();
	LsgFlaeche = 0;
	Feld.markant[0] = 10+Math.abs(rz.nextInt())%(Bildbreite-20); // Horizontale Position Kreuzpunkt
	Feld.markant[1] = 10+Math.abs(rz.nextInt())%(Bildhoehe-20); // Vertikale Position Kreuzpunkt
    LsgFlaeche = Feld.markant[0]*Feld.markant[1]+(Bildbreite-Feld.markant[0])*(Bildhoehe-Feld.markant[1]);
	LsgFlaeche = LsgFlaeche*100/(Bildbreite*Bildhoehe);
 }

 public void Menuewahl_Kreuz() {
	Random rz;
	rz = new Random();
	LsgFlaeche = 0;
	Feld.markant[0] = 10+Math.abs(rz.nextInt())%(Bildbreite-20); // linke Ecke von vertikalem Balken
	Feld.markant[1] = 10+Math.abs(rz.nextInt())%(Bildhoehe-20); // obere Ecke von horizontalem Balken
	Feld.markant[2] = 10+Math.abs(rz.nextInt())%(Bildbreite-Feld.markant[0]-10); // Breite von vertikalem Balken
	Feld.markant[3] = 10+Math.abs(rz.nextInt())%(Bildhoehe-Feld.markant[1]-10); // Hoehe von horizontalem Balken
	LsgFlaeche = Feld.markant[2]*(Bildhoehe-Feld.markant[3]) + Feld.markant[3] * Bildbreite;
	LsgFlaeche = LsgFlaeche*100/(Bildbreite*Bildhoehe);
 }


 public void Menuewahl_Dreieck() {
	Random rz;
	rz = new Random();
	LsgFlaeche = 0;
	Feld.markant[0] = 10+Math.abs(rz.nextInt())%(Bildbreite-20); // oberer Dreieckpunkt
	Feld.markant[1] = 5+Math.abs(rz.nextInt())%(Bildbreite/2-5); // unterer linker Dreieckpunkt
	Feld.markant[2] = Bildbreite-Feld.markant[1];  // unterer rechter Dreieckpunkt
	LsgFlaeche = ((Feld.markant[2]-Feld.markant[1]) * Bildhoehe)/2 ;
	LsgFlaeche = (Bildbreite*Bildhoehe)-LsgFlaeche;
	LsgFlaeche = LsgFlaeche*100/(Bildbreite*Bildhoehe);
 }

public void Menuewahl_Drachen() {
	Random rz;
	rz = new Random();
	LsgFlaeche = 0;
	Feld.markant[0] = 10+Math.abs(rz.nextInt())%(Bildbreite-20); // oberer Punkt des Drachens
	Feld.markant[1] = Feld.markant[0]; // unterer Punkt des Drachens
	Feld.markant[2] = 10+Math.abs(rz.nextInt())%(Bildhoehe-20); // linker Punkt des Drachens
	Feld.markant[3] = Feld.markant[2]; // rechter Punkt des Drachens
	LsgFlaeche = 50;
 }

public void Menuewahl_Sechsecke() {
	Random rz;
	rz = new Random();
	LsgFlaeche = 0;
	Feld.markant[0] = 10+Math.abs(rz.nextInt())%(Bildbreite-20); // linkester Punkt der oberen rechten Ecke
	Feld.markant[1] = Bildbreite-Feld.markant[0]; // rechtester Punkt der unteren linken Ecke
	Feld.markant[2] = 10+Math.abs(rz.nextInt())%(Bildhoehe-20);	// unterster Punkt der oberen rechten Ecke
	Feld.markant[3] = Bildhoehe-Feld.markant[2];  // oberster Punkt der unteren linken Ecke
	LsgFlaeche = Feld.markant[1]*(Bildhoehe-Feld.markant[2]) + (Bildbreite-Feld.markant[0])*Feld.markant[3];
	LsgFlaeche = LsgFlaeche*50/(Bildbreite*Bildhoehe);
 }

 public void Menuewahl_Muster() {
	Random rz;
	rz = new Random();
	int fall1 = (Math.abs(rz.nextInt())%20)+2;
	int fall2 = (Math.abs(rz.nextInt())%20)+2;
	int zaehler1 = (Math.abs(rz.nextInt())%10);;
	int zaehler2 = 1;
	LsgFlaeche = 0;
	for (int i=0; i<Anzx; i++) {
		for (int j=0; j<Anzy; j++) {
			Felder[i][j] = 1;

			if (zaehler1++ == fall1) {
				Felder[i][j] = 0;
				LsgFlaeche++;
				zaehler1 = 1;
			}
			if (zaehler2++ == fall2) {
				Felder[i][j] = 0;
				LsgFlaeche++;
				zaehler2 = 1;
			}
		}
	}
	LsgFlaeche = LsgFlaeche*100/(Anzx*Anzy);
 }

 public void Menuewahl_Zufall() {
	Random rz;
	rz = new Random();
	int fall = (Math.abs(rz.nextInt())%2)+2;
	LsgFlaeche = 0;
	for (int i=0; i<Anzx; i++) {
		for (int j=0; j<Anzy; j++) {
			Felder[i][j] = Math.abs(rz.nextInt())%fall;
			if (Felder[i][j] == 0) {
				LsgFlaeche++;
			}
		}
	}
	LsgFlaeche = LsgFlaeche*100/(Anzx*Anzy);
 }

 public void Menuewahl_Bild() {
  // Vorinstallieren
  for (int i=0; i<Anzx; i++) {
	   for (int j=0; j<Anzy; j++) {
		   Felder[i][j] = 0;
	   }
   }
  // String aus Datei lesen
  Random rz;
  rz = new Random();
  int fall = (Math.abs(rz.nextInt())%Anzbilder);
  String Dateistring = "Bild"+fall+".txt";
  String PixelString = "";
  String thisLine;
   try {
	   BufferedReader in = new BufferedReader ( new InputStreamReader ( (new URL(getCodeBase(), Dateistring)).openStream(), "8859_1" ) );
	   do {}
	   while( (thisLine=in.readLine()).indexOf("// (Anfang)") != 0 );
	   while( (thisLine=in.readLine()).indexOf("// (Ende)") != 0 ) {
		   PixelString = PixelString+thisLine+",";
	   }
	   in.close();
	} catch (Exception e) {
		System.out.println("error " + e);
	}
	String sneu = "";
	int i=0;
	int pi=0;
	int pj=0;
	LsgFlaeche = 0;
	do {
		if ( ('0'<= PixelString.charAt(i)) && (PixelString.charAt(i)<='9') ) {
			sneu = ""+PixelString.charAt(i);
			double db;
			try {
				db = Double.valueOf(sneu).doubleValue();
			} catch (java.lang.NumberFormatException ex) {
				db = 0.0;
			}
			if (Felder[pi][pj] < Farbwahl.length) {
				Felder[pi][pj]=Math.round((float)(db));
			}
			if (Felder[pi][pj] == 0) {
				LsgFlaeche++;
			}
			pi++;
		}
		if ( pi == Anzx ) {
			pi = 0;
			pj++;
		}
		i++;
	}
	while( (pj < Anzy) && (i<PixelString.length()) );
	LsgFlaeche = LsgFlaeche*100/(Anzx*Anzy);
}

////////////////////////////////////////////////////////////
//         Die oberen Einstellungen                       //
////////////////////////////////////////////////////////////

	class oben extends Panel {
	FlaechSch theapplet;
	Panel buttons = new Panel();
	Panel inputs = new Panel();

	Button[] Knopfl = new Button[3];
	Label Kommentar1 = new Label();
	TextField AntwortTxt;
	Label Kommentar2 = new Label();


	public oben (FlaechSch a) {
		theapplet = a;
		setLayout(new GridLayout(3,1));
		setFont(new Font("Helvetica",Font.PLAIN,14));

		Knopfl[0]=new Button("Neue Situation");
		Knopfl[1]=new Button("Kontrolle");
		Knopfl[2]=new Button("Zur\u00Fcck");
		buttons.setLayout(new FlowLayout());
		for (int i=0; i<3; i++) {
			Knopfl[i].setBackground(Color.lightGray);
			Knopfl[i].setFont(SchriftArt);
			buttons.add(Knopfl[i]);
		}


		ActionListener ActionTextField = new ActionListener() {
			public void actionPerformed(ActionEvent e){
				Feld.Kontrollsituation = true;
				String s1 = AntwortTxt.getText().trim();
				double d1 = 0.0;
				try {
					d1 = Double.valueOf(s1).doubleValue();
				} catch (java.lang.NumberFormatException ex) {
					d1 = 0.0;
				}
				Antwort = (int)(d1);
				if (Antwort < 0) {
					Antwort = 0;
				}
				if (Antwort > 100) {
					Antwort = 100;
				}
				Feld.maleAbweichung(Antwort, LsgFlaeche);
			}
		};


		ActionListener ActionButton0 = new ActionListener() {
			public void actionPerformed(ActionEvent e){
				Menue();
			}
		};

		ActionListener ActionButton1 = new ActionListener() {
			public void actionPerformed(ActionEvent e){
				Feld.Kontrollsituation = true;
				String s1 = AntwortTxt.getText().trim();
				double d1 = 0.0;
				try {
					d1 = Double.valueOf(s1).doubleValue();
				} catch (java.lang.NumberFormatException ex) {
					d1 = 0.0;
				}
				Antwort = (int)(d1);
				if (Antwort < 0) {
					Antwort = 0;
				}
				if (Antwort > 100) {
					Antwort = 100;
				}
				Feld.maleAbweichung(Antwort, LsgFlaeche);
			}
		};


		ActionListener ActionButton2 = new ActionListener() {
			public void actionPerformed(ActionEvent e){
				Kontrolle.Kommentar1.setText("W\u00E4hle einen Aufgabentyp:");
				Kontrolle.Kommentar2.setText("   ");
				Kontrolle.AntwortTxt.setText("  ");
				Feld.Kontrollsituation = false;
				Feld.Liniensituation = false;
				Menuesituation = true;
				Feld.maleMenue();
				theapplet.remove (Kontrolle);
				theapplet.validate();
			}
		};


		Kommentar1.setText("Sch\u00E4tze wie viel Prozent der Fl\u00E4che rot ist:");
		Kommentar1.setAlignment(Label.CENTER);
		Kommentar1.setFont(SchriftArt);
		AntwortTxt = new TextField(" ", 7);
		AntwortTxt.setFont(SchriftArtklein);
		Kommentar2.setText(" % ");
		Kommentar2.setAlignment(Label.LEFT);
		Kommentar2.setFont(SchriftArt);

		inputs.setLayout(new FlowLayout());
		inputs.add(AntwortTxt);
		inputs.add(Kommentar2);

		add(buttons);
		add(Kommentar1);
		Knopfl[0].addActionListener(ActionButton0);
		Knopfl[1].addActionListener(ActionButton1);
		Knopfl[2].addActionListener(ActionButton2);
		add(inputs);

		AntwortTxt.addActionListener(ActionTextField);

	} // public oben

 	} // class oben

////////////////////////////////////////////////////////////
//                   Das Feld                            //
////////////////////////////////////////////////////////////

 class mitte extends Panel {

  FlaechSch theapplet;
  Image img;
  Graphics imggc;
  int width,height;
  int Knopfbreite, Knopfhoehe;

  int[] markant = new int[4];

  int Buttond = 50;
  int Buttonx1 = Buttond;
  int Buttony1 = ya;
  int linie_aktiv = -1;

  boolean Liniensituation = false;
  boolean Kontrollsituation = false;
  int[] linie = new int[4]; // Punkte der Linien
  int lr = 6; 				// Liniendurchmesser;
  int ld = 2*lr;


  public mitte(FlaechSch a) {
	  theapplet = a;
	  addMouseListener( new meinMA());
	  addMouseMotionListener( new meinMML());
  }


   public void init() {
      if (img==null) {
    	  Dimension d=size();
    	  width=d.width; height=d.height;
    	  img=createImage(width,height);
    	  imggc=img.getGraphics();
    	  img=createImage(width,height);
    	  imggc=img.getGraphics();
    	  imggc.setFont (new Font("Helvetica", Font.PLAIN, 14));
    	  Knopfbreite = (width-40)/3-20;
    	  Knopfhoehe = (height-20)/3-10;
    	  Knopfbreite = Knopfbreite - Knopfbreite%diami;
       	  Knopfhoehe = Knopfhoehe - Knopfhoehe%diami;
    	  Anix = Knopfbreite / diami;
    	  Aniy = Knopfhoehe / diami;
    	  xa = (width-diam*Anzx)/2;
    	  linie[0] = xa;
    	  linie[1] = xa+Bildbreite;
    	  linie[2] = ya;
    	  linie[3] = ya+Bildhoehe;
    	  validate();
       }
    }


   public void paint(Graphics gc) {
      if (img!=null) gc.drawImage(img,0,0,theapplet);
   }

   public void update(Graphics gc) {
      if (img!=null) gc.drawImage(img,0,0,theapplet);
   }

// -------------------------------------------
//      Menue malen
// -------------------------------------------

   public void ini_Menuewahl_Bild() {
	  // Vorinstallieren
	  for (int i=0; i<Anzx; i++) {
		   for (int j=0; j<Anzy; j++) {
			   for (int z=0; z<3; z++) {
				   Icons[z][i][j] = 1;
		   		}
		   }
	   }
	  // Mustericon
	  int fall = 4;
	  int zaehler = 1;
	  for (int i=0; i<Anzx; i++) {
		  for (int j=0; j<Anzy; j++) {
			  if (zaehler != fall) {
				zaehler++;
			  }
			  else {
				Icons[0][i][j] = 0;
				zaehler = 1;
			  }
		  }
	  }
	  Random rz;
	  rz = new Random();
	  fall = 2;
	  for (int i=0; i<Anzx; i++) {
		  for (int j=0; j<Anzy; j++) {
				Icons[1][i][j] = Math.abs(rz.nextInt())%fall;
		  }
	  }

	 // Bildicon
	  Icons[2][15][5] = 0;	  Icons[2][17][5] = 0;
	  Icons[2][15][6] = 0;	  Icons[2][17][6] = 0;
	  Icons[2][14][6] = 0;	  Icons[2][18][6] = 0;
	             Icons[2][16][7] = 0;
	  Icons[2][14][8] = 0;	  Icons[2][18][8] = 0;
	  Icons[2][15][8] = 0;	  Icons[2][17][8] = 0;
	  Icons[2][15][9] = 0;	  Icons[2][17][9] = 0;
   }


   void maleMusterKnopf(int qxa, int qya, int nr) {
		  for (int i=0; i<Anix; i++) {
			  for (int j=0; j<Aniy; j++) {
				  imggc.setColor (Farbwahl[Icons[nr][i][j]] );
				  imggc.fillRect (qxa+i*diami, qya+j*diami, diami, diami);
			 }
		  }
		  imggc.setColor (Color.black);
		  imggc.drawRect (qxa-1, qya-1, Anix*diami+1, Aniy*diami+1);

		  repaint();
	  } // void faerbe

  void maleMenue() {
	  imggc.setColor (Color.WHITE);
	  imggc.fillRect(0,0,width,height);
	  imggc.setFont(SchriftArt);

	  maleRechteck   (40,              20,               Knopfbreite, Knopfhoehe, Knopfbreite/2-5, Knopfhoehe/3-5, Knopfbreite/4, Knopfhoehe/3);
	  maleQuadrate   (60+Knopfbreite,  20,               Knopfbreite, Knopfhoehe, Knopfbreite/2, Knopfhoehe/3);
	  maleKreuz      (80+2*Knopfbreite,20,               Knopfbreite, Knopfhoehe, Knopfbreite/2, Knopfhoehe/3, Knopfbreite/5, Knopfhoehe/3);

	  maleDreieck    (40,              30+Knopfhoehe, Knopfbreite, Knopfhoehe, 5*Knopfbreite/12, Knopfbreite/3, 2*Knopfbreite/3);
	  maleDrachen    (60+Knopfbreite,  30+Knopfhoehe, Knopfbreite, Knopfhoehe, 5*Knopfbreite/12, 3*Knopfbreite/4, Knopfhoehe/2-10, Knopfhoehe/2+5);
	  maleSechsecke  (80+2*Knopfbreite,30+Knopfhoehe,            Knopfbreite, Knopfhoehe, 2*Knopfbreite/5, 3*Knopfbreite/5, 3*Knopfhoehe/4, Knopfhoehe/4);

	  maleMusterKnopf(40,              40+2*Knopfhoehe, 0);
	  maleMusterKnopf(60+Knopfbreite,  40+2*Knopfhoehe, 1);
	  maleMusterKnopf(80+2*Knopfbreite,40+2*Knopfhoehe, 2);

	  imggc.setColor (Color.black);
	  for (int i=0; i<3; i++) {
		  for (int j=0; j<3; j++) {
			  imggc.drawString (""+(3*i+j+1), 45+j*(Knopfbreite+20), 35+i*(Knopfhoehe+10));
		  }
	  }
	  repaint();

  }


//-------------------------------------------
//   Bilder malen
//-------------------------------------------

  void maleBildflaeche() {
	  imggc.setColor (Color.WHITE);
	  imggc.fillRect(0,0,width,height);
	  switch (Menuewahl) {
	  	case 1: {maleRechteck(xa, ya, Bildbreite, Bildhoehe, markant[0], markant[1], markant[2], markant[3]);
	  			break;}
	  	case 2: {maleQuadrate(xa, ya, Bildbreite, Bildhoehe, markant[0], markant[1]);
	  			break;}
	  	case 3: {maleKreuz(xa, ya, Bildbreite, Bildhoehe, markant[0], markant[1], markant[2], markant[3]);
	  			break;}

	  	case 4: {maleDreieck(xa, ya, Bildbreite, Bildhoehe, markant[0], Feld.markant[1], markant[2]);
	  			break;}
	  	case 5: {maleDrachen(xa, ya, Bildbreite, Bildhoehe, markant[0], markant[1], markant[2], markant[3]);
	  			break;}
	  	case 6: {maleSechsecke(xa, ya, Bildbreite, Bildhoehe, markant[0], markant[1], markant[2], markant[3]);
	  			break;}

	  	case 7: {maleBild(xa, ya, Anzx, Anzy, diam); break;}
	  	case 8: {maleBild(xa, ya, Anzx, Anzy, diam); break;}
	  	case 9: {maleBild(xa, ya, Anzx, Anzy, diam); break;}
	  }
	  maleLinien();
	  if (Kontrollsituation) {
		  maleAbweichung(Antwort, LsgFlaeche);
	  }
	  repaint();
  }


  void maleRechteck(int qxa, int qya, int qbreit, int qhoch, int xm_rel, int ym_rel, int qb_rel, int qh_rel) {
	  // Quadrat Anfang -> qxa, qya; Quadrat Masse -> qbreit, qhoch;
	  // Besondere Punkte xm_rel, ym_rel
	  imggc.setColor (Farbwahl[1] );
	  imggc.fillRect (qxa, qya, qbreit, qhoch);

	  imggc.setColor (Farbwahl[0] );
	  imggc.fillRect (qxa+xm_rel, qya+ym_rel, qb_rel, qh_rel);

	  imggc.setColor (Color.black);
	  imggc.drawRect (qxa, qya, qbreit, qhoch);
	  repaint();
  } //



  void maleQuadrate(int qxa, int qya, int qbreit, int qhoch, int xm_rel, int ym_rel) {
	  // Quadrat Anfang -> qxa, qya; Quadrat Masse -> qbreit, qhoch;
	  // Besondere Punkte xm_rel, ym_rel
	  imggc.setColor (Farbwahl[1] );
	  imggc.fillRect (qxa, qya, qbreit, qhoch);

	  imggc.setColor (Farbwahl[0] );
	  imggc.fillRect (qxa, qya, xm_rel, ym_rel);
	  imggc.fillRect (qxa+xm_rel, qya+ym_rel, qbreit-xm_rel, qhoch-ym_rel);

	  imggc.setColor (Color.black);
	  imggc.drawRect (qxa, qya, qbreit, qhoch);
	  repaint();
  } //




  void maleKreuz(int qxa, int qya, int qbreit, int qhoch, int xm_rel, int ym_rel, int xbreit, int yhoch) {
	  // Quadrat Anfang -> qxa, qya; Quadrat Masse -> qbreit, qhoch;
	  // Besondere Punkte xm_rel, ym_rel
	  imggc.setColor (Farbwahl[1] );
	  imggc.fillRect (qxa, qya, qbreit, qhoch);

	  imggc.setColor (Farbwahl[0] );
	  imggc.fillRect (qxa+xm_rel, qya, xbreit, qhoch);
	  imggc.fillRect (qxa, qya+ym_rel, qbreit, yhoch);

	  imggc.setColor (Color.black);
	  imggc.drawRect (qxa, qya, qbreit, qhoch);
	  repaint();
  }


  void maleDreieck(int qxa, int qya, int qbreit, int qhoch, int xo_rel, int xul_rel, int xur_rel) {
	  // Quadrat Anfang -> qxa, qya; Quadrat Masse -> qbreit, qhoch;
	  // Besondere Punkte xo_rel, xu_rel, yl_rel, yr_rel
	  Polygon Quadrat;
	  	  Quadrat = new Polygon();
		  Quadrat.addPoint (qxa+xo_rel, qya);
		  Quadrat.addPoint (qxa+xul_rel, qya+qhoch);
		  Quadrat.addPoint (qxa+xur_rel, qya+qhoch);
		  imggc.setColor (Farbwahl[0] );
		  imggc.fillRect (qxa, qya, qbreit, qhoch);

		  imggc.setColor (Farbwahl[1] );
		  imggc.fillPolygon (Quadrat);

		  imggc.setColor (Color.black);
		  imggc.drawRect (qxa, qya, qbreit, qhoch);
		  repaint();
	  }

  void maleDrachen(int qxa, int qya, int qbreit, int qhoch, int xo_rel, int xu_rel, int yl_rel, int yr_rel) {
	  // Quadrat Anfang -> qxa, qya; Quadrat Masse -> qbreit, qhoch;
	  // Besondere Punkte xo_rel, xu_rel, yl_rel, yr_rel
	  Polygon Quadrat;
	  	  Quadrat = new Polygon();
		  Quadrat.addPoint (qxa+xo_rel, qya);
		  Quadrat.addPoint (qxa, qya+yl_rel);
		  Quadrat.addPoint (qxa+xu_rel, qya+qhoch);
		  Quadrat.addPoint (qxa+qbreit, qya+yr_rel);
		  imggc.setColor (Farbwahl[0] );
		  imggc.fillRect (qxa, qya, qbreit, qhoch);

		  imggc.setColor (Farbwahl[1] );
		  imggc.fillPolygon (Quadrat);

		  imggc.setColor (Color.black);
		  imggc.drawRect (qxa, qya, qbreit, qhoch);
		  repaint();
	  }

  void maleSechsecke(int qxa, int qya, int qbreit, int qhoch, int xo_rel, int xu_rel, int yl_rel, int yr_rel) {
	  // Quadrat Anfang -> qxa, qya; Quadrat Masse -> qbreit, qhoch;
	  // Besondere Punkte xo_rel, xu_rel, yl_rel, yr_rel
	  Polygon Quadrat;
	  	  Quadrat = new Polygon();
		  Quadrat.addPoint (qxa+xo_rel, qya);
		  Quadrat.addPoint (qxa, qya);
		  Quadrat.addPoint (qxa, qya+yl_rel);
		  Quadrat.addPoint (qxa+xu_rel, qya+qhoch);
		  Quadrat.addPoint (qxa+qbreit, qya+qhoch);
		  Quadrat.addPoint (qxa+qbreit, qya+yr_rel);
		  imggc.setColor (Farbwahl[0] );
		  imggc.fillRect (qxa, qya, qbreit, qhoch);

		  imggc.setColor (Farbwahl[1] );
		  imggc.fillPolygon (Quadrat);

		  imggc.setColor (Color.black);
		  imggc.drawRect (qxa, qya, qbreit, qhoch);
		  repaint();
	  }

  void maleBild(int qxa, int qya, int Ax, int Ay, int Kgr) {
	  for (int i=0; i<Ax; i++) {
		  for (int j=0; j<Ay; j++) {
			  imggc.setColor (Farbwahl[Felder[i][j]] );
			  imggc.fillRect (qxa+i*Kgr, qya+j*Kgr, Kgr, Kgr);
		 }
	  }
	  imggc.setColor (Color.black);
	  imggc.drawRect (xa-1, ya-1, Anzx*diam+1, Anzy*diam+1);
	  repaint();
  }




  void maleLinien() {
	imggc.setFont(SchriftArt);

   // LinienKnopf
   imggc.setColor (Color.lightGray );
   imggc.fill3DRect (Buttonx1, Buttony1, Buttond, Buttond, !Liniensituation);
   imggc.setColor (Color.black);
   imggc.drawLine (Buttonx1+Buttond/2, Buttony1+3, Buttonx1+Buttond/2, Buttony1+Buttond-6);
   imggc.drawLine (Buttonx1+3, Buttony1+Buttond/2, Buttonx1+Buttond-6, Buttony1+Buttond/2);
   imggc.fillOval (Buttonx1+Buttond/2-3, Buttony1+3, 6, 6);
   imggc.fillOval (Buttonx1+3, Buttony1+Buttond/2-3, 6, 6);

    if (Liniensituation) {
       imggc.setColor (Color.lightGray);
       imggc.fillRect( xa, ya-ld-10, Bildbreite, ld);
       imggc.fillRect( xa-ld-10, ya, ld, Bildhoehe);
	   imggc.setColor (Color.darkGray);
	   imggc.drawLine( xa, ya-ld/2-10, xa+Bildbreite, ya-ld/2-10);
	   imggc.drawLine( xa-ld/2-10, ya, xa-ld/2-10, ya+Bildhoehe);
	   int abst = Bildbreite/10;
       for (int i=0; i<10; i++) {
    	   imggc.drawLine (xa+i*abst, ya-ld/2-13, xa+i*abst, ya-ld/2-7);
       	   imggc.drawLine (xa-ld/2-13, ya+i*abst, xa-ld/2-7, ya+i*abst);
       }
       for (int i=0; i<3; i++) {
    	   imggc.drawLine (xa+5*i*abst, ya-ld-10, xa+5*i*abst, ya-10);
       	   imggc.drawLine (xa-ld-10, ya+5*i*abst, xa-10, ya+5*i*abst);
    	   imggc.fillRect (xa+5*i*abst-1, ya-ld-10, 3, ld+1);
       	   imggc.fillRect (xa-ld-10-1, ya+5*i*abst, ld+1, 3);
       }
	   imggc.drawLine (linie[0], ya-10, linie[0], ya+Bildhoehe);
	   imggc.drawLine (linie[1], ya-10, linie[1], ya+Bildhoehe);
	   imggc.drawLine (xa-10, linie[2], xa+Bildbreite, linie[2]);
	   imggc.drawLine (xa-10, linie[3], xa+Bildbreite, linie[3]);

	   imggc.fillOval (linie[0]-lr+1, ya-ld-10+1, ld-2, ld-2);
	   imggc.fillOval (linie[1]-lr+1, ya-ld-10+1, ld-2, ld-2);
	   imggc.fillOval (xa-ld-10+1, linie[2]-lr+1, ld-2, ld-2);
	   imggc.fillOval (xa-ld-10+1, linie[3]-lr+1, ld-2, ld-2);
   }
   repaint();
 }


//-------------------------------------------
//  Abweichung malen
//-------------------------------------------


  void maleAbweichung(int Antw, int Lsg) {
  int Strahlax = xa+Bildbreite+80;
  Strahlax = xa+Bildbreite+(xa-(Buttonx1+Buttond));
  int Strahlb = 30;

  	  imggc.setColor (Color.white);
  	  imggc.fillRect (xa+Bildbreite, ya ,width, height);

	  FontMetrics fm = getFontMetrics(SchriftArt);
	  imggc.setFont(SchriftArt);

	  int exakt=Lsg*Bildhoehe/100;
	  imggc.setColor (Farbwahl[1]);
	  imggc.fillRect(Strahlax, ya, Strahlb, Bildhoehe-exakt);
	  imggc.setColor (Farbwahl[0]);
	  imggc.fillRect(Strahlax, ya+Bildhoehe-exakt, Strahlb, exakt);

      imggc.setColor (Color.lightGray);
	   int abst = Bildbreite/10;
       for (int i=0; i<10; i++) {
       	   imggc.drawLine (Strahlax, ya+i*abst, Strahlax+Strahlb, ya+i*abst);
       }

	  imggc.setColor (Color.black);
	  imggc.drawRect(Strahlax, ya, Strahlb, Bildhoehe);

	  int Txtanf = fm.stringWidth(" "+Lsg+"%")+10;
	  imggc.drawString ("exakter Wert", Strahlax-Txtanf+2, ya-5);
	  if (Lsg < 80) {
		  imggc.drawString (" "+Lsg+"%", Strahlax-Txtanf+5, ya+Bildhoehe-exakt-3);
	  }
	  else {
		  imggc.drawString (" "+Lsg+"%", Strahlax-Txtanf+5, ya+Bildhoehe-exakt+16+3);
	  }
	  imggc.drawLine (Strahlax-Txtanf, ya, Strahlax-Txtanf, ya+Bildhoehe-exakt);
	  imggc.drawLine (Strahlax-Txtanf, ya+Bildhoehe-exakt, Strahlax+Strahlb, ya+Bildhoehe-exakt);
	  imggc.drawLine (Strahlax, ya+Bildhoehe-exakt, Strahlax-5, ya+Bildhoehe-exakt-5);
	  imggc.drawLine (Strahlax, ya+Bildhoehe-exakt, Strahlax-5, ya+Bildhoehe-exakt+5);

	  Txtanf = fm.stringWidth(" "+Antw+"%")+10;
	  int Txtanf2 = fm.stringWidth("gesch\u00E4tzer Wert");
	  int vglexakt = Bildhoehe-Antw*Bildhoehe/100;
	  imggc.drawString ("gesch\u00E4tzer Wert", Strahlax+Strahlb+Txtanf-Txtanf2-2, ya+Bildhoehe+20);
	  if (Antw > 20) {
		  imggc.drawString (" "+Antw+"%", Strahlax+Strahlb+5, ya+vglexakt+16+3);
	  }
	  else {
		  imggc.drawString (" "+Antw+"%", Strahlax+Strahlb+5, ya+vglexakt-3);
	  }
	  imggc.drawLine (Strahlax+Strahlb+Txtanf, ya+vglexakt, Strahlax+Strahlb+Txtanf, ya+Bildhoehe+5);
	  imggc.drawLine (Strahlax, ya+vglexakt, Strahlax+Strahlb+Txtanf, ya+vglexakt);
	  imggc.drawLine (Strahlax+Strahlb, ya+vglexakt, Strahlax+Strahlb+5, ya+vglexakt-5);
	  imggc.drawLine (Strahlax+Strahlb, ya+vglexakt, Strahlax+Strahlb+5, ya+vglexakt+5);

	  repaint();
  } // void faerbe


	class meinMML extends MouseMotionAdapter {

		public void mouseDragged(MouseEvent me) {
				int mx = me.getX();
				int my = me.getY();

				if (linie_aktiv == -1) {
					for (int i=0; i<2; i++) {
						if ( (Math.abs(mx-linie[i])<=lr) && (Math.abs(my-(ya-ld/2-10))<=lr) ) {
							linie_aktiv = i;
						}
					}
					for (int i=2; i<4; i++) {
						if ( (Math.abs(mx-(xa-ld/2-10))<=lr) && (Math.abs(my-ld/2-linie[i])<=lr) ) {
							linie_aktiv = i;
						}
					}
				}
				if ( (linie_aktiv==0) || (linie_aktiv==1) )  {
					linie[linie_aktiv] = mx;
					if (linie[linie_aktiv] < xa) {
						linie[linie_aktiv] = xa;
					}
					if (linie[linie_aktiv] > xa+Bildbreite) {
						linie[linie_aktiv] = xa+Bildbreite;
					}
					maleBildflaeche();
				}
				if ( (linie_aktiv==2) || (linie_aktiv==3) )  {
					linie[linie_aktiv] = my;
					if (linie[linie_aktiv] < ya) {
						linie[linie_aktiv] = ya;
					}
					if (linie[linie_aktiv] > ya+Bildbreite) {
						linie[linie_aktiv] = ya+Bildhoehe;
					}
						maleBildflaeche();
				}
				maleLinien();
		} // Ende MouseDragged

} // Ende meinMML

	class meinMA extends MouseAdapter {

		public void mouseReleased( MouseEvent me ) {
			int mx = me.getX();
			int my = me.getY();
			if (Menuesituation) {
	   // Auswahl der verschiedenen Bildersituationen
				int merkx = -1;
				int merky = -1;
				  for (int i=0; i<3; i++) {
					  if ( ( (40+i*(Knopfbreite+20)) <= mx )
						&& ( mx <= (40+i*(Knopfbreite+20)+Knopfbreite) ) ) {
						  merkx = i;
					  }
				  }
				  for (int i=0; i<3; i++) {
					  if ( ( (20+i*(Knopfhoehe+10)) <= my )
						&& ( my <= (20+i*(Knopfhoehe+10)+Knopfhoehe) ) ) {
						  merky = i;
					  }
				  }
				  Menuewahl = merkx+ 3*merky +1;
				  Menue();
				  Menuesituation = false;
				  theapplet.add ("North", Kontrolle);
				  theapplet.validate();
			}
			else {

		// verschieben der Linien
				if (linie_aktiv > - 1) {
					linie_aktiv = -1;
				}
				else {
		// waehle Buttons
					// Linien
					if ( (Buttonx1 <= mx) && (mx <= (Buttonx1+Buttond)) &&
						 (Buttony1 <= my) && (my <= (Buttony1+Buttond)) ) {
						Liniensituation = !Liniensituation;
						maleBildflaeche();
						}
				}
			}
		} // Ende mouseReleased


	} // Ende meinMA
} // Mitte

} // class FlaechSch
